diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/he/he-frame-exchange-manager.h ns-3.34/src/wifi/model/he/he-frame-exchange-manager.h
--- ns-3.33/src/wifi/model/he/he-frame-exchange-manager.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/he/he-frame-exchange-manager.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,230 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef HE_FRAME_EXCHANGE_MANAGER_H
+#define HE_FRAME_EXCHANGE_MANAGER_H
+
+#include "ns3/vht-frame-exchange-manager.h"
+#include "mu-snr-tag.h"
+#include <map>
+#include <unordered_map>
+
+namespace ns3 {
+
+class MultiUserScheduler;
+class ApWifiMac;
+class StaWifiMac;
+class CtrlTriggerHeader;
+
+/**
+ * Map of PSDUs indexed by STA-ID
+ */
+typedef std::unordered_map <uint16_t /* staId */, Ptr<WifiPsdu> /* PSDU */> WifiPsduMap;
+/**
+ * Map of const PSDUs indexed by STA-ID
+ */
+typedef std::unordered_map <uint16_t /* staId */, Ptr<const WifiPsdu> /* PSDU */> WifiConstPsduMap;
+
+/**
+ * \ingroup wifi
+ *
+ * HeFrameExchangeManager handles the frame exchange sequences
+ * for HE stations.
+ */
+class HeFrameExchangeManager : public VhtFrameExchangeManager
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+  HeFrameExchangeManager ();
+  virtual ~HeFrameExchangeManager ();
+
+  uint16_t GetSupportedBaBufferSize (void) const override;
+  bool StartFrameExchange (Ptr<QosTxop> edca, Time availableTime, bool initialFrame) override;
+  void SetWifiMac (const Ptr<RegularWifiMac> mac) override;
+  void CalculateAcknowledgmentTime (WifiAcknowledgment* acknowledgment) const override;
+
+  /**
+   * Set the Multi-user Scheduler associated with this Frame Exchange Manager.
+   *
+   * \param muScheduler the Multi-user Scheduler associated with this Frame Exchange Manager
+   */
+  void SetMultiUserScheduler (const Ptr<MultiUserScheduler> muScheduler);
+
+  /**
+   * Get the PSDU in the given PSDU map that is addressed to the given MAC address,
+   * if any, or a null pointer, otherwise.
+   *
+   * \param to the MAC address
+   * \param psduMap the PSDU map
+   * \return the PSDU, if any, or a null pointer, otherwise
+   */
+  static Ptr<WifiPsdu> GetPsduTo (Mac48Address to, const WifiPsduMap& psduMap);
+
+  /**
+   * Set the UL Target RSSI subfield of every User Info fields of the given
+   * Trigger Frame to the most recent RSSI observed from the corresponding
+   * station.
+   *
+   * \param trigger the given Trigger Frame
+   */
+  virtual void SetTargetRssi (CtrlTriggerHeader& trigger) const;
+
+protected:
+  void DoDispose () override;
+
+  void ReceiveMpdu (Ptr<WifiMacQueueItem> mpdu, RxSignalInfo rxSignalInfo,
+                    const WifiTxVector& txVector, bool inAmpdu) override;
+  void EndReceiveAmpdu (Ptr<const WifiPsdu> psdu, const RxSignalInfo& rxSignalInfo,
+                        const WifiTxVector& txVector, const std::vector<bool>& perMpduStatus) override;
+  Time GetTxDuration (uint32_t ppduPayloadSize, Mac48Address receiver,
+                      const WifiTxParameters& txParams) const override;
+  bool SendMpduFromBaManager (Ptr<QosTxop> edca, Time availableTime, bool initialFrame) override;
+
+  /**
+   * Send a map of PSDUs as a DL MU PPDU.
+   * Note that both <i>psduMap</i> and <i>txParams</i> are moved to m_psduMap and
+   * m_txParams, respectively, and hence are left in an undefined state.
+   *
+   * \param psduMap the map of PSDUs to send
+   * \param txParams the TX parameters to use to transmit the PSDUs
+   */
+  void SendPsduMapWithProtection (WifiPsduMap psduMap, WifiTxParameters& txParams);
+
+  /**
+   * Forward a map of PSDUs down to the PHY layer.
+   *
+   * \param psduMap the map of PSDUs to transmit
+   * \param txVector the TXVECTOR used to transmit the MU PPDU
+   */
+  void ForwardPsduMapDown (WifiConstPsduMap psduMap, WifiTxVector& txVector);
+
+  /**
+   * Take the necessary actions after that some BlockAck frames are missing
+   * in response to a DL MU PPDU. This method must not be called if all the
+   * expected BlockAck frames were received.
+   *
+   * \param psduMap a pointer to PSDU map transmitted in a DL MU PPDU
+   * \param staMissedBlockAckFrom set of stations we missed a BlockAck frame from
+   * \param nSolicitedStations the number of stations solicited to send a TB PPDU
+   */
+  virtual void BlockAcksInTbPpduTimeout (WifiPsduMap* psduMap,
+                                         const std::set<Mac48Address>* staMissedBlockAckFrom,
+                                         std::size_t nSolicitedStations);
+
+  /**
+   * Take the necessary actions after that some TB PPDUs are missing in
+   * response to Trigger Frame. This method must not be called if all the
+   * expected TB PPDUs were received.
+   *
+   * \param psduMap a pointer to PSDU map transmitted in a DL MU PPDU
+   * \param staMissedTbPpduFrom set of stations we missed a TB PPDU from
+   * \param nSolicitedStations the number of stations solicited to send a TB PPDU
+   */
+  virtual void TbPpduTimeout (WifiPsduMap* psduMap,
+                              const std::set<Mac48Address>* staMissedTbPpduFrom,
+                              std::size_t nSolicitedStations);
+
+  /**
+   * Take the necessary actions after that a Block Ack is missing after a
+   * TB PPDU solicited through a Trigger Frame.
+   *
+   * \param psdu the PSDU in the TB PPDU
+   * \param txVector the TXVECTOR used to transmit the TB PPDU
+   */
+  virtual void BlockAckAfterTbPpduTimeout (Ptr<WifiPsdu> psdu, const WifiTxVector& txVector);
+
+  /**
+   * Return a TXVECTOR for the UL frame that the station will send in response to
+   * the given Trigger frame, configured with the BSS color and transmit power
+   * level to use for the consequent HE TB PPDU.
+   * Note that this method should only be called by non-AP stations only.
+   *
+   * \param trigger the received Trigger frame
+   * \param triggerSender the MAC address of the AP sending the Trigger frame
+   * \return TXVECTOR for the HE TB PPDU frame
+   */
+  WifiTxVector GetHeTbTxVector (CtrlTriggerHeader trigger, Mac48Address triggerSender) const;
+
+  /**
+   * Build a MU-BAR Trigger Frame starting from the TXVECTOR used to respond to
+   * the MU-BAR (in case of multiple responders, their TXVECTORs need to be
+   * "merged" into a single TXVECTOR) and from the BlockAckReq headers for
+   * every recipient.
+   * Note that the number of recipients must match the number of users addressed
+   * by the given TXVECTOR.
+   *
+   * \param responseTxVector the given TXVECTOR
+   * \param recipients the list of BlockAckReq headers indexed by the station's AID
+   * \return the MPDU containing the built MU-BAR
+   */
+  Ptr<WifiMacQueueItem> PrepareMuBar (const WifiTxVector& responseTxVector,
+                                      std::map<uint16_t, CtrlBAckRequestHeader> recipients) const;
+
+  /**
+   * Send a Multi-STA Block Ack frame after the reception of some TB PPDUs.
+   *
+   * \param txParams the TX parameters for the Trigger Frame that solicited the TB PPDUs
+   */
+  void SendMultiStaBlockAck (const WifiTxParameters& txParams);
+
+  /**
+   * Send QoS Null frames in response to a Basic or BSRP Trigger Frame. The number
+   * of QoS Null frames that are actually aggregated depends on the available time
+   * as indicated by the Trigger Frame and is at most 8 (one QoS Null frame per TID).
+   *
+   * \param trigger the Basic or BSRP Trigger Frame content
+   * \param hdr the MAC header of the Basic or BSRP Trigger Frame
+   */
+  void SendQosNullFramesInTbPpdu (const CtrlTriggerHeader& trigger, const WifiMacHeader& hdr);
+
+  Ptr<ApWifiMac> m_apMac;                             //!< MAC pointer (null if not an AP)
+  Ptr<StaWifiMac> m_staMac;                           //!< MAC pointer (null if not a STA)
+
+private:
+  /**
+   * Send the current PSDU map as a DL MU PPDU.
+   */
+  void SendPsduMap (void);
+
+  /**
+   * Take the necessary actions when receiveing a Basic Trigger Frame.
+   *
+   * \param trigger the Basic Trigger Frame content
+   * \param hdr the MAC header of the Basic Trigger Frame
+   */
+  void ReceiveBasicTrigger (const CtrlTriggerHeader& trigger, const WifiMacHeader& hdr);
+
+  WifiPsduMap m_psduMap;                              //!< the A-MPDU being transmitted
+  WifiTxParameters m_txParams;                        //!< the TX parameters for the current PPDU
+  Ptr<MultiUserScheduler> m_muScheduler;              //!< Multi-user Scheduler (HE APs only)
+  Ptr<WifiMacQueueItem> m_triggerFrame;               //!< Trigger Frame being sent
+  std::set<Mac48Address> m_staExpectTbPpduFrom;       //!< set of stations expected to send a TB PPDU
+  EventId m_multiStaBaEvent;                          //!< Sending a Multi-STA BlockAck event
+  MuSnrTag m_muSnrTag;                                //!< Tag to attach to Multi-STA BlockAck frames
+  bool m_triggerFrameInAmpdu;                         //!< True if the received A-MPDU contains an MU-BAR
+};
+
+} //namespace ns3
+
+#endif /* HE_FRAME_EXCHANGE_MANAGER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/he/he-operation.cc ns-3.34/src/wifi/model/he/he-operation.cc
--- ns-3.33/src/wifi/model/he/he-operation.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/he/he-operation.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,187 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2017 Sébastien Deronne
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#include "he-operation.h"
+
+namespace ns3 {
+
+HeOperation::HeOperation ()
+  : m_bssColor (0),
+    m_defaultPEDuration (0),
+    m_twtRequired (0),
+    m_heDurationBasedRtsThreshold (0),
+    m_partialBssColor (0),
+    m_maxBssidIndicator (0),
+    m_txBssidIndicator (0),
+    m_bssColorDisabled (0),
+    m_dualBeacon (0),
+    m_basicHeMcsAndNssSet (0),
+    m_heSupported (0)
+{
+}
+
+WifiInformationElementId
+HeOperation::ElementId () const
+{
+  return IE_EXTENSION;
+}
+
+WifiInformationElementId
+HeOperation::ElementIdExt () const
+{
+  return IE_EXT_HE_OPERATION;
+}
+
+void
+HeOperation::SetHeSupported (uint8_t heSupported)
+{
+  m_heSupported = heSupported;
+}
+
+uint8_t
+HeOperation::GetInformationFieldSize () const
+{
+  //we should not be here if he is not supported
+  NS_ASSERT (m_heSupported > 0);
+  return 7;
+}
+
+void
+HeOperation::SetHeOperationParameters (uint32_t ctrl)
+{
+  m_bssColor = ctrl & 0x3f;
+  m_defaultPEDuration = (ctrl >> 6) & 0x07;
+  m_twtRequired = (ctrl >> 9) & 0x01;
+  m_heDurationBasedRtsThreshold = (ctrl >> 10) & 0x03ff;
+  m_partialBssColor = (ctrl >> 20) & 0x01;
+  m_maxBssidIndicator = (ctrl >> 21) & 0xff;
+  m_txBssidIndicator = (ctrl >> 29) & 0x01;
+  m_bssColorDisabled = (ctrl >> 30) & 0x01;
+  m_dualBeacon = (ctrl >> 31) & 0x01;
+}
+
+uint32_t
+HeOperation::GetHeOperationParameters () const
+{
+  uint32_t val = 0;
+  val |= m_bssColor & 0x3f;
+  val |= (m_defaultPEDuration & 0x07) << 6;
+  val |= (m_twtRequired & 0x01) << 9;
+  val |= (m_heDurationBasedRtsThreshold & 0x03ff) << 10;
+  val |= (m_partialBssColor & 0x01) << 20;
+  val |= (m_maxBssidIndicator & 0xff) << 21;
+  val |= (m_txBssidIndicator & 0x01) << 29;
+  val |= (m_bssColorDisabled & 0x01) << 30;
+  val |= (m_dualBeacon & 0x01) << 31;
+  return val;
+}
+
+void
+HeOperation::SetMaxHeMcsPerNss (uint8_t nss, uint8_t maxHeMcs)
+{
+  NS_ASSERT ((maxHeMcs >= 7 && maxHeMcs <= 11) && (nss >= 1 && nss <= 8));
+  uint8_t val = 3; //3 means not supported
+  if (maxHeMcs > 9) //MCS 0 - 11
+    {
+      val = 2;
+    }
+  else if (maxHeMcs > 7) //MCS 0 - 9
+    {
+      val = 1;
+    }
+  else if (maxHeMcs == 7) //MCS 0 - 7
+    {
+      val = 0;
+    }
+  m_basicHeMcsAndNssSet |= ((val & 0x03) << ((nss - 1) * 2));
+}
+
+uint16_t
+HeOperation::GetBasicHeMcsAndNssSet (void) const
+{
+  return m_basicHeMcsAndNssSet;
+}
+
+void
+HeOperation::SetBssColor (uint8_t bssColor)
+{
+  NS_ABORT_UNLESS (bssColor < 64); // 6 bits
+  m_bssColor = bssColor;
+  m_bssColorDisabled = 0;
+}
+
+uint8_t
+HeOperation::GetBssColor (void) const
+{
+  return m_bssColor;
+}
+
+Buffer::Iterator
+HeOperation::Serialize (Buffer::Iterator i) const
+{
+  if (m_heSupported < 1)
+    {
+      return i;
+    }
+  return WifiInformationElement::Serialize (i);
+}
+
+uint16_t
+HeOperation::GetSerializedSize () const
+{
+  if (m_heSupported < 1)
+    {
+      return 0;
+    }
+  return WifiInformationElement::GetSerializedSize ();
+}
+
+void
+HeOperation::SerializeInformationField (Buffer::Iterator start) const
+{
+  if (m_heSupported == 1)
+    {
+      //write the corresponding value for each bit
+      start.WriteHtolsbU32 (GetHeOperationParameters ());
+      start.WriteU16 (GetBasicHeMcsAndNssSet ());
+      //todo: VHT Operation Information (variable)
+    }
+}
+
+uint8_t
+HeOperation::DeserializeInformationField (Buffer::Iterator start, uint8_t length)
+{
+  Buffer::Iterator i = start;
+  uint32_t heOperationParameters = i.ReadLsbtohU32 ();
+  m_basicHeMcsAndNssSet = i.ReadU16 ();
+  SetHeOperationParameters (heOperationParameters);
+  //todo: VHT Operation Information (variable)
+  return length;
+}
+
+std::ostream &
+operator << (std::ostream &os, const HeOperation &HeOperation)
+{
+  os << HeOperation.GetHeOperationParameters () << "|"
+     << HeOperation.GetBasicHeMcsAndNssSet ();
+  return os;
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/he/he-operation.h ns-3.34/src/wifi/model/he/he-operation.h
--- ns-3.33/src/wifi/model/he/he-operation.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/he/he-operation.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,132 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2017 Sébastien Deronne
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#ifndef HE_OPERATION_H
+#define HE_OPERATION_H
+
+#include "ns3/wifi-information-element.h"
+
+namespace ns3 {
+
+/**
+ * \brief The HE Operation Information Element
+ * \ingroup wifi
+ *
+ * This class knows how to serialise and deserialise
+ * the HE Operation Information Element
+ */
+class HeOperation : public WifiInformationElement
+{
+public:
+  HeOperation ();
+
+  // Implementations of pure virtual methods of WifiInformationElement
+  WifiInformationElementId ElementId () const override;
+  WifiInformationElementId ElementIdExt () const override;
+  uint8_t GetInformationFieldSize () const override;
+  void SerializeInformationField (Buffer::Iterator start) const override;
+  uint8_t DeserializeInformationField (Buffer::Iterator start, uint8_t length) override;
+  /* This information element is a bit special in that it is only
+     included if the STA is a HE STA. To support this we
+     override the Serialize and GetSerializedSize methods of
+     WifiInformationElement. */
+  Buffer::Iterator Serialize (Buffer::Iterator start) const override;
+  uint16_t GetSerializedSize () const override;
+
+  /**
+   * Set the HE supported information element.
+   *
+   * \param heSupported the HE supported information element
+   */
+  void SetHeSupported (uint8_t heSupported);
+
+  /**
+   * Set the HE Operation Parameters field in the HE Operation information element.
+   *
+   * \param ctrl the HE Operation Parameters field in the HE Operation information element
+   */
+  void SetHeOperationParameters (uint32_t ctrl);
+  /**
+   * Set the Basic HE-MCS and NSS field in the HE Operation information element
+   * by specifying the tuple (<i>nss</i>, <i>maxMcs</i>).
+   *
+   * \param nss the NSS
+   * \param maxHeMcs the maximum supported HE-MCS value corresponding to that NSS
+   */
+  void SetMaxHeMcsPerNss (uint8_t nss, uint8_t maxHeMcs);
+
+  /**
+   * Return the HE Operation Parameters field in the HE Operation information element.
+   *
+   * \return the HE Operation Parameters field in the HE Operation information element
+   */
+  uint32_t GetHeOperationParameters (void) const;
+  /**
+   * Return the Basic HE-MCS And Nss field in the HE Operation information element.
+   *
+   * \return the Basic HE-MCS And Nss field in the HE Operation information element
+   */
+  uint16_t GetBasicHeMcsAndNssSet (void) const;
+  /**
+   * Set the BSS color
+   * \param bssColor the BSS color value
+   */
+  void SetBssColor (uint8_t bssColor);
+  /**
+   * Get the BSS color
+   * \return the BSS color value
+   */
+  uint8_t GetBssColor (void) const;
+
+
+private:
+  //HE Operation Parameters fields
+  uint8_t m_bssColor;                     //!< BSS color
+  uint8_t m_defaultPEDuration;            //!< default PE duration
+  uint8_t m_twtRequired;                  //!< TWT required
+  uint16_t m_heDurationBasedRtsThreshold; //!< HE duration based RTS threshold
+  uint8_t m_partialBssColor;              //!< partial BSS color
+  uint8_t m_maxBssidIndicator;            //!< max BSSID indicator
+  uint8_t m_txBssidIndicator;             //!< TX BSSID indicator
+  uint8_t m_bssColorDisabled;             //!< BSS color disabled
+  uint8_t m_dualBeacon;                   //!< Dual Beacon
+
+  //Basic HE-MCS and NSS Set
+  uint16_t m_basicHeMcsAndNssSet; ///< basic HE MCS NSS set
+
+  //TODO: VHT Operation Information subfields not defined in the standard yet.
+
+  /// This is used to decide whether this element should be added to the frame or not
+  uint8_t m_heSupported;
+};
+
+/**
+ * output stream output operator
+ *
+ * \param os output stream
+ * \param HeOperation the HE operation
+ *
+ * \returns output stream
+ */
+std::ostream &operator << (std::ostream &os, const HeOperation &HeOperation);
+
+} //namespace ns3
+
+#endif /* HE_OPERATION_H */
